#!/usr/bin/env python
"""
"cholesterol.itp", "dppc.itp", "cholesterol-pos.pdb" and 
"cholesterol-neg.pdb" are needed
"""
from random import *
from math import *
import sys, os, re

if len(sys.argv) < 1:
   sys.exit("usage: ./replace.py lipid.pdb")

os.system("editconf -f %s -o %s" % (sys.argv[1], "tmp.pdb"))

numReplace    = 13
atomsPerLipid = 50
numLipid      = 64
offset_lipid  = 4

rndLipidListU = []
rndLipidListL = []
rndLipidList  = []
while len(rndLipidListU) < numReplace:
   rndLipid = choice(xrange(1, numLipid+1))
   if (rndLipid not in rndLipidListU):
      rndLipidListU.append(rndLipid)
      rndLipidList.append(rndLipid)
      
while len(rndLipidListL) < numReplace:
   rndLipid = choice(xrange(numLipid+1, 2*numLipid+1))
   if (rndLipid not in rndLipidListL):
      rndLipidListL.append(rndLipid)
      rndLipidList.append(rndLipid)
      
cholMassDict = {"CH3":15.03500, "CB":12.01100, "CH2":14.02700, "CH1":13.01900,
                "OA":15.99940, "HO":1.00800, "CR61":13.01900}
lipidMassDict = {"LC3":15.0350, "LNL":14.0067, "LH2":14.0270, "LC2":14.0270,
                 "LOS":15.9994, "LP":30.9738, "LOM":15.9994, "LH1":13.0190,
	         "LC":12.0110, "LO":15.9994, "LP2":14.0270, "LP3":15.0350}

outputfile = open("output.pdb", "w")

inputfile_lipid   = open("tmp.pdb", "r")
lines_lipid       = inputfile_lipid.readlines()
inputfile_lipid.close()

inputfile_chol_itp = open("cholesterol.itp", "r")
lines_chol_itp    = inputfile_chol_itp.readlines()
inputfile_chol_itp.close()
cholMass = []
for line in lines_chol_itp:
   if "  CHOL" in line:
      cholMass.append(cholMassDict[line.split()[1]])

inputfile_lipid_itp = open("dppc.itp", "r")
lines_lipid_itp    = inputfile_lipid_itp.readlines()
inputfile_lipid_itp.close()
lipidMass = []
for line in lines_lipid_itp:
   if "  DPPC" in line:
      lipidMass.append(lipidMassDict[line.split()[1]])

for line_lipid in lines_lipid:
   #Description lines in the pdb file
   if ("ATOM" not in line_lipid):
      print>>outputfile, line_lipid[0:-1]
   #if there's cholesterol molecule in the file, print
   elif ("CHO" in line_lipid) or ("SOL" in line_lipid):
      print>>outputfile, line_lipid[0:-1]
   #lipid molecules that are not to be replaced
   elif ("ATOM" in line_lipid) and (int(line_lipid[22:26]) not in rndLipidList):
      print>>outputfile, line_lipid[0:-1]
   #lipid molecules to be replaced
   elif (int(line_lipid[22:26]) in rndLipidList) and (line_lipid[13:16] == "C1 "):
      rndLipid = int(line_lipid[22:26])
      #rotate a cholesterol molecule with an arbitrary angle
      #and read the lines into a list
      deltaTheta = random() * 360.
      if (rndLipid<=numLipid):
         cmd_rot = "editconf -f cholesterol-pos.pdb \
                   -o cholesterol-rot.pdb -rotate 0 0 %f" % deltaTheta
      else:
         cmd_rot = "editconf -f cholesterol-neg.pdb \
                   -o cholesterol-rot.pdb -rotate 0 0 %f" % deltaTheta
      os.system(cmd_rot)
      inputfile_rot_pdb = open("cholesterol-rot.pdb", 'r')
      lines_rot_pdb = inputfile_rot_pdb.readlines()
      inputfile_rot_pdb.close()
      os.system("rm -f cholesterol-rot.pdb")
      #chol part starts
      mxSum_chol = 0.
      mySum_chol = 0.
      mzSum_chol = 0.
      cholCOM = []
      mSum_chol = sum(cholMass)
      j = 0
      for line in lines_rot_pdb:
	 if (line.split()[0]=="ATOM"):
            mxSum_chol += cholMass[j] * float(line[30:37])
            mySum_chol += cholMass[j] * float(line[38:45])
            mzSum_chol += cholMass[j] * float(line[46:53])
            j+=1
      cholCOM.append(mxSum_chol/mSum_chol)
      cholCOM.append(mySum_chol/mSum_chol)
      cholCOM.append(mzSum_chol/mSum_chol)
      #chol part over

      #lipid part starts, calcuate the COM of the lipid
      #which is to be replaced by cholesterol
      mSum_lipid = sum(lipidMass)
      mxSum_lipid = 0. 
      mySum_lipid = 0. 
      mzSum_lipid = 0.
      lipidCOM = []
      for i in xrange(0,atomsPerLipid):
	 mxSum_lipid += lipidMass[i] *\
                	float(lines_lipid[offset_lipid+(rndLipid-1)*atomsPerLipid+i][30:37])
	 mySum_lipid += lipidMass[i] *\
                	float(lines_lipid[offset_lipid+(rndLipid-1)*atomsPerLipid+i][38:45])
	 mzSum_lipid += lipidMass[i] *\
                	float(lines_lipid[offset_lipid+(rndLipid-1)*atomsPerLipid+i][46:53])
      lipidCOM.append(mxSum_lipid/mSum_lipid)
      lipidCOM.append(mySum_lipid/mSum_lipid)
      lipidCOM.append(mzSum_lipid/mSum_lipid)
      #lipid part over

      #replace lipid with chol so that their COMs match
      displace = []
      displace.append(lipidCOM[0]-cholCOM[0])
      displace.append(lipidCOM[1]-cholCOM[1])
      displace.append(lipidCOM[2]-cholCOM[2])
         
      for line_chol in lines_rot_pdb:
         if (line_chol.split()[0] == "ATOM"):
            x_new = float(line_chol[30:37]) + displace[0]
            y_new = float(line_chol[38:45]) + displace[1]
            z_new = float(line_chol[46:53]) + displace[2]
            print>>outputfile, line_chol[0:21], \
	                     "%4i   " % rndLipid,\
	                     "%8.3f" % x_new, \
			     "%7.3f" % y_new, \
			     "%7.3f" % z_new, \
			     line_chol[55:-1]
      #replace lipid with chol so that their COMs match done

outputfile.close()
os.system("editconf -f output.pdb -o output.pdb")
os.system("rm -r tmp.pdb")
